#include<iostream>
using namespace std;

int f(int c, int i){
  int k=1;
	for (int j=1; j<=i; j++) k=(k*c)%998244353;
	return k;
}

int main(){
  int n,m,c;
  cin>>n>>m;
  int* b=new int[m];
  for(int i=1; i<=m; i++) cin>>b[i];
  cin>>c;

  int* a=new int[n];
  for(int i=1; i<=n; i++) a[i]=i;

  for(int i=0; i<=n-m; i++)
	  for(int j=1; j<=m; j++) a[i+b[j]]=a[i+j];

  int x=0;
  for(int i=1; i<=n; i++) x=(x+f(c,i)*a[i])%998244353;

  cout<<x<<endl;
  return 0;
}